package edu.nps.moves.dis7.enumerations;

import java.nio.ByteBuffer;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;

import edu.nps.moves.dis7.pdus.*;

/**
 * Generated from XML, SISO-REF-010-v28, 2020-05-07<br>
 * UID 25 marshal size 8<br>
 * ExpendableAirCategory
 */
public enum ExpendableAirCategory implements Category
{
    /** Other */
    OTHER (0, "Other"),
    /** Chaff */
    CHAFF (1, "Chaff"),
    /** Flare */
    FLARE (2, "Flare"),
    /** Combined Chaff and Flare */
    COMBINED_CHAFF_AND_FLARE (3, "Combined Chaff and Flare"),
    /** Active Emitter */
    ACTIVE_EMITTER (4, "Active Emitter"),
    /** Passive Decoy */
    PASSIVE_DECOY (5, "Passive Decoy"),
    /** Winged Decoy */
    WINGED_DECOY (6, "Winged Decoy"),
    /** Signal/Illumination Flare */
    SIGNAL_ILLUMINATION_FLARE (7, "Signal/Illumination Flare"),
    /** Smoke Generator */
    SMOKE_GENERATOR (8, "Smoke Generator"),
    /** Combined Flare and Smoke Generator */
    COMBINED_FLARE_AND_SMOKE_GENERATOR (12, "Combined Flare and Smoke Generator"),
    /** SAR Night Light (SRNL) */
    SAR_NIGHT_LIGHT_SRNL (13, "SAR Night Light (SRNL)"),
    /** SAR Buoy */
    SAR_BUOY (14, "SAR Buoy");

    private int value;
    private final String description;

    ExpendableAirCategory(int value, String description)
    {
        this.value = value;
        this.description = description;
    }

    public int getValue()
    {
        return value;
    }

    public String getDescription()
    {
        return description;
    }
    
    public static int getEnumBitWidth()
    {
      return 8;
    }

    public static ExpendableAirCategory getEnumForValue(int i)
    {
       for(ExpendableAirCategory val: ExpendableAirCategory.values()) {
          if(val.getValue()==i)
              return val;
       }
       System.err.println("No enumeration found for value " + i + " of enumeration ExpendableAirCategory");
       return null;
    }


    public void marshal(DataOutputStream dos) throws IOException
    {
        dos.writeByte(getValue());
    }
    
    public void marshal(ByteBuffer byteBuffer) throws Exception
    {
        byteBuffer.put((byte)getValue());
    }

    public static ExpendableAirCategory unmarshalEnum (DataInputStream dis) throws Exception
    {
       /* try {
            value = dis.readUnsignedByte();
        }
        catch(IOException ex) {
            showError(ex);
        } */
        
        return getEnumForValue(dis.readByte());
    } 

    public static ExpendableAirCategory unmarshalEnum(ByteBuffer byteBuffer) throws Exception
    {
        /*
        try {
            value = (int)byteBuffer.get();
        }
        catch(Exception ex) {
            showError(ex);
        }
        */
        return getEnumForValue(byteBuffer.get());
    }

  /**
   * Returns size of this serialized (marshalled) object in bytes
   * See <a href="https://en.wikipedia.org/wiki/Marshalling_(computer_science)" target="_blank">https://en.wikipedia.org/wiki/Marshalling_(computer_science)</a>
   * @return serialized size in bytes
   */
    public int getMarshalledSize()
    {
        return 1; // 8 bits
    }
    
  /**
   * Provide simple identifier
   * @return ID number and name
   */
    @Override
    public String toString()
    {
        return "ExpendableAirCategory " + getValue() + " " + name(); 
    }
}
